//
//  ClubChatAppDelegate.m
//  ClubChat
//
//  Created by 이규주 on 09. 03. 16.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import <CoreGraphics/CoreGraphics.h>
#import "ClubChatAppDelegate.h"
#import "ClubChatLoginViewController.h"
#import "ClubChatMainViewController.h"
#import "ClubChatChatViewController.h"
#import "ClubChatData.h"

@interface ClubChatAppDelegate(PrivateMethods)
//대기실화면을보여준다..
-(void) viewChatMain;
//대화방화면을 보여준다..
-(void) viewChatRoom;
//대화방화면을 나간다..
-(void) exitChatRoom;
-(void)receiveMsgProcess:(NSString *)header msgArray:(NSArray *)array;
@end

@implementation ClubChatAppDelegate

@synthesize chatName;
@synthesize ipAddress;

- (void)applicationDidFinishLaunching:(UIApplication *)application {
	//NSLog(@"applicationDidFinishLaunching");
	
	//서버로전송할 노티피케이션처리관련 등록..
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(sendMsg:) name:@"sendMsg" object:nil];
	
	sendDataPool=[[NSMutableArray alloc] init];
	receiveDataPool=[[NSMutableArray alloc] init];
	
	process=NO;
	isShowAlert=YES;
	
    // Override point for customization after app launch
    [window addSubview:navigationController.view];
    [window makeKeyAndVisible];
}

//보낼세지처리..
-(void)sendMsg:(NSNotification *)notification{
	NSLog(@"ClubChatAppDelegate sendMsg");
	ClubChatData *data=(ClubChatData *)[notification object];
	
	NSString *header=data.header;
	
	if([header hasPrefix:@"/로그인"]){
		ipAddress=(NSString *)[data.array objectAtIndex:0];
		chatName=(NSString *)[data.array objectAtIndex:1];
		[ipAddress retain];
		[chatName retain];
		
		NSLog(@"ipAddress:%@ chatName:%@",ipAddress,chatName);
		
		NSHost *host = [NSHost hostWithAddress:ipAddress];
		
		[NSStream getStreamsToHost:host port:4321 inputStream:&iStream outputStream:&oStream];
		// 이렇게 얻어진 두개의 스트림은 autorelease 이기 때문에 반드시 retain 해둔다.
		[iStream retain];
		[oStream retain];
		
		// 이 스트림들에서 발생하는 메시지를 스스로 처리하도록 delegate 를 지정한다.
		[iStream setDelegate:self];
		[oStream setDelegate:self];
		[iStream scheduleInRunLoop:[NSRunLoop currentRunLoop] forMode:NSDefaultRunLoopMode];
		[oStream scheduleInRunLoop:[NSRunLoop currentRunLoop] forMode:NSDefaultRunLoopMode];
		[iStream open];
		[oStream open];
		
		//stringWithFormat로 쓰면 이상하게 전송이 안되는 현상이있다..
		//이거하나로 며칠 끙끙댐....
		//NSString *str = [NSString stringWithFormat:@"/로그인|개떵이",chatName]; 
		NSString *str = @"/로그인|";
		str=[str stringByAppendingString:chatName];
		str=[str stringByAppendingString:@"\n"];
		
		[sendDataPool addObject:str];
		[self stream:oStream handleEvent:NSStreamEventHasSpaceAvailable];
		
	}else{
		for(NSString *param in data.array){
			header=[header stringByAppendingString:@"|"];
			header=[header stringByAppendingString:param];
		}
		header=[header stringByAppendingString:@"\n"];
		
		[sendDataPool addObject:header];
		[self stream:oStream handleEvent:NSStreamEventHasSpaceAvailable];
	}
	
	NSLog(@"처리할 header : %@ : msg : %@",header,data.msg);
}

- (void)stream:(NSStream *)stream handleEvent:(NSStreamEvent)eventCode {
	switch(eventCode) {
        case NSStreamEventHasSpaceAvailable:
        {
            NSLog(@"NSStreamEventHasSpaceAvailable %@",stream);
            if(!stream){
				UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"ClubChat" 
																message:@"연결에 실패했습니다. 입력정보를 확인하십시요."
															   delegate:nil 
													  cancelButtonTitle:@"OK" 
													  otherButtonTitles: nil];
				[alert show];	
				[alert release];
			}else if (stream == oStream) {
				if(!process){
					
					process=YES;
					
					NSString *str;
					while([sendDataPool count]!=0){
						str=(NSString *)[sendDataPool objectAtIndex:0];
						const char *sendMsg=[str cStringUsingEncoding:CFStringConvertEncodingToNSStringEncoding(kCFStringEncodingEUC_KR)];
						[oStream write:sendMsg maxLength:strlen(sendMsg)];
						NSLog(@"전송대기풀 카운트 %d",[sendDataPool count]);
						[sendDataPool removeObjectAtIndex:0];
					}
					process=NO;
				}
            }
            break;
        }
			
        case NSStreamEventHasBytesAvailable:
        {
			NSLog(@"NSStreamEventHasBytesAvailable");
			const uint8_t buf[1024];
            unsigned int len = 0;
            len = [(NSInputStream *)stream read:buf maxLength:1024];
			
			NSString *sourceData=[[NSString alloc] initWithBytes:buf length:len encoding:CFStringConvertEncodingToNSStringEncoding(kCFStringEncodingEUC_KR)];
			NSArray *processArray=[sourceData componentsSeparatedByString:@"\n"];
			
			for(NSString *data in processArray){
				//trim처리..
				data=[data stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
				
				NSArray *array=[data componentsSeparatedByString:@"|"];
				NSString *header=(NSString *)[array objectAtIndex:0];
				
				if([header isEqualToString:@""]){
					//아무데이터도 아니라면 처리하지않는다..
					break;
				}else if([header isEqualToString:@"/로긴승인"]){
					NSLog(@"input 로긴승인: %@",data);
					[self viewChatMain];
				}else if([header isEqualToString:@"/대화명변경승인"]){
					NSLog(@"input 대화명변경승인: %@",data);
					chatName=[array objectAtIndex:1];
					[self receiveMsgProcess:header msgArray:array];
				}else if([header isEqualToString:@"/개설승인"]){
					//NSLog(@"input 개설승인: %@",data);
					//개설승인후 바로 입장승인이 오기때문에 
					//그에대한 처리를 별도로하지않는다
				}else if([header isEqualToString:@"/입장승인"]){
					NSLog(@"input 입장승인: %@",data);
					[self viewChatRoom];
				}else if([header isEqualToString:@"/퇴장승인"]){
					NSLog(@"input 퇴장승인: %@",data);
					[self exitChatRoom];
				}else{
					NSLog(@"input 기타: %@",data);
					[self receiveMsgProcess:header msgArray:array];
				}
			}
            break;
		}
			
        case NSStreamEventEndEncountered:
        {
			NSLog(@"NSStreamEventEndEncountered");
            //[stream close];
            //[stream removeFromRunLoop:[NSRunLoop currentRunLoop] forMode:NSDefaultRunLoopMode];
            //[stream release];
            //stream = nil; // stream is ivar, so reinit it
			//연결이 끊겼을경우...
			[navigationController popToRootViewControllerAnimated:NO];
            break;
        }
		
		case NSStreamEventErrorOccurred:
		{
			NSLog(@"스트림에러발생~");
			if(isShowAlert){
				
				isShowAlert=NO;
				
				UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"ClubChat" 
																message:@"연결에 실패했습니다. 입력정보를 확인하십시요."
															   delegate:nil 
													  cancelButtonTitle:@"OK" 
													  otherButtonTitles: nil];
				[alert setDelegate:self];
				[alert show];	
				[alert release];
			}
		}
	}
}
- (void)alertView:(UIAlertView *)alertView didDismissWithButtonIndex:(NSInteger)buttonIndex{
	isShowAlert=YES;
}
-(void)receiveMsgProcess:(NSString *)header msgArray:(NSArray *)array{
	NSMutableArray *mArray=[[NSMutableArray alloc] initWithArray:array];
	[mArray removeObjectAtIndex:0];
	NSMutableArray *sendArray=[[NSMutableArray alloc] init];
	
	//배열내용에서 빈공백문자가 들어간것을 걸러냄...
	NSString *tmp;
	for(int i=0;i<mArray.count;i++){
		tmp=[mArray objectAtIndex:i];
		
		if(![tmp isEqualToString:@""]){
			[sendArray addObject:tmp];
		}
	}
	ClubChatData *data=[[ClubChatData alloc] initWithHeader:header andWithArray:sendArray];
	[[NSNotificationCenter defaultCenter] postNotificationName:@"receiveMsg" object:data];
	
	[mArray release];
}
//대기실화면을보여준다..
-(void) viewChatMain{
	NSLog(@"viewChatMain");
	
	UIViewController *viewController=[[ClubChatMainViewController alloc] initWithNibName:@"ClubChatMainViewController" bundle:nil];
	[navigationController pushViewController:viewController animated:NO];
	[viewController release];
}

//대화방화면을보여준다..
-(void) viewChatRoom{
	NSLog(@"viewChatRoom");
	
	UIViewController *viewController=[[ClubChatChatViewController alloc] initWithNibName:@"ClubChatChatViewController" bundle:nil];
	[navigationController pushViewController:viewController animated:YES];
	[viewController release];
}

//대화방화면에서 나간다
//퇴장...
-(void) exitChatRoom{
	NSLog(@"exitChatRoom");
	
	[navigationController popViewControllerAnimated:YES];
}

- (void)dealloc {
	[navigationController release];
	[sendDataPool release];
	[receiveDataPool release];
    [window release];
    [super dealloc];
}
@end
