//
//  ClubChatMainEtcViewController.m
//  ClubChat
//
//  Created by 이규주 on 09. 05. 13.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "ClubChatMainEtcViewController.h"
#import "ClubChatAppDelegate.h"
#import "ClubChatData.h"

@implementation ClubChatMainEtcViewController

@synthesize superViewController;
@synthesize isModalProcess;

- (void)viewDidLoad {
    [super viewDidLoad];
	
	isModalProcess=YES;
	
	NSLog(@"ClubChatMainEtcViewController viewDidLoad");

}
- (void)textFieldDidBeginEditing:(UITextField *)textField{
	NSLog(@"textFieldDidBeginEditing");
}
- (void)textFieldDidEndEditing:(UITextField *)textField{
	NSLog(@"textFieldDidEndEditing");
	[textField resignFirstResponder];
}
- (BOOL)textFieldShouldReturn:(UITextField *)textField{
	NSLog(@"textFieldShouldReturn");
	[textField resignFirstResponder];
	
	return YES;
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(selectionDidChange:) name:@"UITableViewSelectionDidChangeNotification" object:nil];
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(receiveMsg:) name:@"receiveMsg" object:nil];
}
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
	
	if(isModalProcess){
		[self dismissModalViewControllerAnimated:NO];
		//[detailViewcontroller dismissModalViewControllerAnimated:NO];
		[self.view setFrame:CGRectMake(0.0f,0.0f,320.0f,460.0f)];
	}
	[chatNameTextField resignFirstResponder];
	[chatRoomNameField resignFirstResponder];
	[chatRoomPasswordField resignFirstResponder];
	
	[[NSNotificationCenter defaultCenter] removeObserver:self];
}

- (void) selectionDidChange:(NSNotification *)notification{
	
	//이화면에 들어가있는 각종테이블의 모든 UITableViewSelectionDidChangeNotification 를 통해서
	//이 메소드가 수행되게되나..특별히 이것외엔 문제될것이 없을것으로 판단되어
	//어느테이블에서 선택되었는지 체크는 하지않고 이렇게 처리한다..
	UITableViewCell *cell=[self.tableView cellForRowAtIndexPath:[NSIndexPath indexPathForRow:1 inSection:1]];

	if(detailViewcontroller.checkedTag==0){
		cell.text=@"인원제한 (무제한까지허용)";
	}else{
		cell.text=[NSString stringWithFormat:@"인원제한 (%@명까지허용)",[ClubChatMainEtcDetailViewController cellIndexToRecognizedInfo:detailViewcontroller.checkedTag]];
	}
}

//서버에서 받은 메세지를 처리한다./대화명변경승인|마르코|
-(void)receiveMsg:(NSNotification *)notification{
	
	ClubChatData *data=(ClubChatData *)[notification object];
	
	if([data.header isEqualToString:@"/대화명변경승인"]){
		NSLog(@"data : %@",data.msg);
		//따로 얼럿처리등은 하지않고..
		//화면에 나오는 정보등만 수정한다.
		ClubChatAppDelegate *delegate=(ClubChatAppDelegate *)[[UIApplication sharedApplication] delegate];
		
		[chatNameTextField setText:@""];
		[chatNameTextField setPlaceholder:[NSString stringWithFormat:@"현재 대화명은 \"%@\" 입니다.",delegate.chatName]];
		[chatNameTextField resignFirstResponder];
		
	}else if([data.header isEqualToString:@"/시스템"]){		
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"ClubChat" 
														message:[data.array objectAtIndex:0]
													   delegate:nil 
											  cancelButtonTitle:@"OK" 
											  otherButtonTitles: nil];
		[alert show];	
		[alert release];
		
		[chatNameTextField setText:@""];
		[chatNameTextField resignFirstResponder];
	}
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 2;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	if(section==0){
		return 2;
	}else{
		return 4;
	}
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
	}
    
	cell.selectionStyle=UITableViewCellSelectionStyleNone;
	
    // Set up the cell...
	if(indexPath.section==0){
		if(indexPath.row==0){
			ClubChatAppDelegate *delegate=(ClubChatAppDelegate *)[[UIApplication sharedApplication] delegate];
			
			chatNameTextField=[[UITextField alloc] initWithFrame:CGRectMake(20,9, 280, 25)];
			[chatNameTextField setBackgroundColor:[UIColor whiteColor]];
			[chatNameTextField setBorderStyle:UITextBorderStyleNone];
			[chatNameTextField setDelegate:self];
			[chatNameTextField setText:@""];
			chatNameTextField.returnKeyType=UIReturnKeyDone;
			[chatNameTextField setPlaceholder:[NSString stringWithFormat:@"현재 대화명은 \"%@\" 입니다.",delegate.chatName]];
			
			[cell addSubview:chatNameTextField];
		}else if(indexPath.row==1){
			UIButton *btn=[UIButton buttonWithType:UIButtonTypeRoundedRect];
			[btn setFrame:CGRectMake(15, 4, 290, 35)];
			[btn setTitle:@"변경" forState:UIControlStateNormal];
			[cell addSubview:btn];
			
			//처리할 이벤트등록..
			[btn addTarget:self action:@selector(touchChatNameChange:) forControlEvents:UIControlEventTouchUpInside];
		}
	}else{
		if(indexPath.row==0){
			chatRoomNameField=[[UITextField alloc] initWithFrame:CGRectMake(20,9, 280, 25)];
			[chatRoomNameField setBackgroundColor:[UIColor whiteColor]];
			[chatRoomNameField setBorderStyle:UITextBorderStyleNone];
			[chatRoomNameField setPlaceholder:@"방제목 입력란"];
			[chatRoomNameField setDelegate:self];
			chatRoomNameField.returnKeyType=UIReturnKeyDone;
			[chatRoomNameField setText:chatRoomNameField.text];
			
			[cell addSubview:chatRoomNameField];
		}else if(indexPath.row==1){
			if(detailViewcontroller.checkedTag==0){
				cell.text=@"인원제한 (무제한까지허용)";
			}else{
				cell.text=[NSString stringWithFormat:@"인원제한 (%@명까지허용)",[ClubChatMainEtcDetailViewController cellIndexToRecognizedInfo:detailViewcontroller.checkedTag]];
			}
			cell.accessoryType=UITableViewCellAccessoryDisclosureIndicator;
		}else if(indexPath.row==2){
			chatRoomPasswordField=[[UITextField alloc] initWithFrame:CGRectMake(20,9, 280, 25)];
			[chatRoomPasswordField setBackgroundColor:[UIColor whiteColor]];
			[chatRoomPasswordField setBorderStyle:UITextBorderStyleNone];
			[chatRoomPasswordField setPlaceholder:@"비밀번호 입력란(없을시 공개방)"];
			[chatRoomPasswordField setDelegate:self];
			chatRoomPasswordField.returnKeyType=UIReturnKeyDone;
			[chatRoomPasswordField setText:chatRoomPasswordField.text];
			[chatRoomPasswordField setSecureTextEntry:YES];
			
			[cell addSubview:chatRoomPasswordField];
		}else if(indexPath.row==3){
			UIButton *btn=[UIButton buttonWithType:UIButtonTypeRoundedRect];
			[btn setFrame:CGRectMake(15, 4, 290, 35)];
			[btn setTitle:@"방만들기" forState:UIControlStateNormal];
			[cell addSubview:btn];
			
			//처리할 이벤트등록..
			[btn addTarget:self action:@selector(touchChatRoomCreate:) forControlEvents:UIControlEventTouchUpInside];
		}
	}
    return cell;
}
//대화명변경처리..
-(void)touchChatNameChange:(id)sender{
	NSString *checkGap=chatNameTextField.text;
	checkGap=[checkGap stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
	
	if([checkGap isEqualToString:@""]){
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"ClubChat" 
														message:@"변경할 대화명을 입력해 주십시요."
													   delegate:nil 
											  cancelButtonTitle:@"OK" 
											  otherButtonTitles: nil];
		[alert show];	
		[alert release];
		
		[chatNameTextField setText:@""];
		
	}else{
		ClubChatData *data=[[ClubChatData alloc] initWithHeader:@"/대화명" andWithMsg:checkGap];
		[[NSNotificationCenter defaultCenter] postNotificationName:@"sendMsg" object:data];
	}
}
//대화방만들기처리..
///만들기|방제목|방비번|인원제한|
-(void)touchChatRoomCreate:(id)sender{
	NSString *chatRoomName=chatRoomNameField.text;
	NSString *chatRoomPassword=chatRoomPasswordField.text;
	NSString *chattersCount=[ClubChatMainEtcDetailViewController cellIndexToRecognizedInfo:detailViewcontroller.checkedTag];
	chatRoomName=[chatRoomName stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
	chatRoomPassword=[chatRoomPassword stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
	
	NSLog(@"방이름 : %@ 인원 : %@ 패스워드 : %@",chatRoomName,chattersCount,chatRoomPassword);
	
	if(!chatRoomName||[chatRoomName isEqualToString:@""]){
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"ClubChat" 
														message:@"대화방제목을 입력해주십시요."
													   delegate:nil 
											  cancelButtonTitle:@"OK" 
											  otherButtonTitles: nil];
		[alert show];	
		[alert release];
		
		[chatRoomNameField setText:@""];
	}else{
		
		if(!chatRoomPassword){
			chatRoomPassword=@"없음";
		}else if([chatRoomPassword isEqualToString:@""]){
			chatRoomPassword=@"없음";
		}
		NSMutableArray *array=[[NSMutableArray alloc] init];
		[array addObject:chatRoomName];
		[array addObject:chatRoomPassword];
		[array addObject:chattersCount];
		
		ClubChatData *data=[[ClubChatData alloc] initWithHeader:@"/만들기" andWithArray:array];
		[[NSNotificationCenter defaultCenter] postNotificationName:@"sendMsg" object:data];
		
		[array release];
	}
}
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // Navigation logic may go here. Create and push another view controller.
	if(indexPath.section==1&&indexPath.row==1){
		
		isModalProcess=NO;
		
		[self presentModalViewController:detailViewcontroller animated:YES];
		[self.modalViewController.view setFrame:CGRectMake(0.0f,0.0f,320.0f,440.0f)];
	}
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section{
	if(section==0){
		return @"대화명변경";
	}else{
		return @"대화방만들기";
	}
}

- (void)dealloc {
	NSLog(@"ClubChatMainEtcViewController delloc");
	
	[chatRoomPasswordField	release];
	[chatRoomNameField		release];
	[chatNameTextField		release];
	[detailViewcontroller	release];
    
	[super dealloc];
}


@end

